<?xml version="1.0" encoding="UTF-8"?>

<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" 
				version="1.0" 
				xmlns:fo="http://www.w3.org/1999/XSL/Format"
				xmlns:exsl="http://exslt.org/common"
				extension-element-prefixes="exsl">

	<xsl:key name="itemByFullpath" match="/ResultList/Data/List/Item" use="@NameFullPath" />
	<xsl:key name="itemBySecClsNm" match="/ResultList/Data/List/Item" use="concat(@NameFullPath,' ',@TS_SecCls.SecClsNm)" />
	<xsl:key name="itemBySecDescNm" match="/ResultList/Data/List/Item" use="concat(@NameFullPath,' ',@TS_SecDesc.SecDescNm)" />
	<xsl:key name="itemByUsrGrp" match="/ResultList/Data/List/Item" use="concat(@NameFullPath,' ',@ACLTS_UsrGrpDir.UsrGrpTyp,' ',@ACLTS_UsrGrpDir.UsrGrpNm)" />

	<xsl:template match="/">
		<fo:root xmlns:fo="http://www.w3.org/1999/XSL/Format">

			<!-- defines page layout -->
			<fo:layout-master-set>
				<fo:simple-page-master master-name="simple" page-width="28cm" page-height="22cm" margin-top="0.5cm" margin-bottom="0.5cm" margin-left="0.5cm" margin-right="0.5cm">
					<fo:region-before extent="0.5cm"/>
					<fo:region-body margin-top="0.5cm" margin-bottom="0.5cm"/>
				</fo:simple-page-master>
			</fo:layout-master-set>


			<!-- defines the content -->
			<fo:page-sequence master-reference="simple">
				<fo:static-content flow-name="xsl-region-before" font-size="8pt">
					<fo:block  text-align="right">
					<fo:page-number/>
					<fo:inline>/</fo:inline>
					<fo:page-number-citation ref-id="terminator"/>
					</fo:block>
				</fo:static-content>

				<fo:flow flow-name='xsl-region-body'>
					<fo:block font-size="14pt" font-weight="bold" text-align="center">
					Access Controls Applied To Fileplan Report
					</fo:block>
				
					<fo:table font-size="8pt" border="1">
						<!-- total 27cm -->
						<fo:table-column column-width="7cm" />
						<fo:table-column column-width="2cm" />
						<fo:table-column column-width="4cm" />
						<fo:table-column column-width="4cm" />						
						<fo:table-column column-width="5cm" />						
						<fo:table-column column-width="5cm" />						
						<!-- Header -->
					
						<fo:table-header font-weight="bold" color="white" background-color="gray">
							<fo:table-row>
								<fo:table-cell padding="2pt" border="solid black">
									<fo:block>
									Object
									</fo:block>
								</fo:table-cell>
								<fo:table-cell padding="2pt" border="solid black">
									<fo:block>
									Type
									</fo:block>
								</fo:table-cell>
								<fo:table-cell padding="2pt" border="solid black">
									<fo:block>
									Named Users
									</fo:block>
								</fo:table-cell>
								<fo:table-cell padding="2pt" border="solid black">
									<fo:block>
									Group Access
									</fo:block>
								</fo:table-cell>
								<fo:table-cell padding="2pt" border="solid black">
									<fo:block>
									Protective marking
									</fo:block>
								</fo:table-cell>
								<fo:table-cell padding="2pt" border="solid black">
									<fo:block>
									Descriptor
									</fo:block>
								</fo:table-cell>
							</fo:table-row>
						</fo:table-header>

						<!-- File Plan -->
						<fo:table-body>
							<xsl:for-each select="/ResultList/Data/List/Item[count(. | key('itemByFullpath', @NameFullPath)[1]) = 1]">
									<xsl:sort select="@NameFullPath" />

									<fo:table-row>

										<fo:table-cell padding="2pt" border="solid black">
											<fo:block text-align="start">

												<xsl:value-of select="@NameFullPath" />		 
											</fo:block>
										</fo:table-cell>

										<fo:table-cell padding="2pt" border="solid black">
											<fo:block text-align="start">
												<xsl:value-of select="@TS_FlPlnCmpntDef.FlPlnCmpntDefNm" />
											</fo:block>
										</fo:table-cell>
										
										<fo:table-cell padding="2pt" border="solid black">
											<xsl:for-each select="key('itemByFullpath', @NameFullPath)[@ACLTS_UsrGrpDir.UsrGrpTyp='1']">
											<xsl:sort select="@ACLTS_UsrGrpDir.UsrGrpNm"/>										
											<xsl:if test="count(. | key('itemByUsrGrp', concat(@NameFullPath,' ',@ACLTS_UsrGrpDir.UsrGrpTyp,' ',@ACLTS_UsrGrpDir.UsrGrpNm))[1]) = 1">
											<fo:block text-align="start">
												<xsl:value-of select="@ACLTS_UsrGrpDir.UsrGrpNm" />
											</fo:block>
											</xsl:if>
											</xsl:for-each>
										</fo:table-cell>

										<fo:table-cell padding="2pt" border="solid black">
											<xsl:for-each select="key('itemByFullpath', @NameFullPath)[@ACLTS_UsrGrpDir.UsrGrpTyp='2']">
											<xsl:sort select="@ACLTS_UsrGrpDir.UsrGrpNm"/>										
											<xsl:if test="count(. | key('itemByUsrGrp', concat(@NameFullPath,' ',@ACLTS_UsrGrpDir.UsrGrpTyp,' ',@ACLTS_UsrGrpDir.UsrGrpNm))[1]) = 1">
											<fo:block text-align="start">
												<xsl:value-of select="@ACLTS_UsrGrpDir.UsrGrpNm" />
											</fo:block>
											</xsl:if>
											</xsl:for-each>
										</fo:table-cell>

										<fo:table-cell padding="2pt" border="solid black">
											<xsl:for-each select="key('itemByFullpath', @NameFullPath)">
											<xsl:sort select="@TS_SecCls.SecClsNm"/>
											<xsl:if test="count(. | key('itemBySecClsNm', concat(@NameFullPath,' ',@TS_SecCls.SecClsNm))[1]) = 1">

											<fo:block text-align="start">
												<xsl:value-of select="@TS_SecCls.SecClsNm" />
											</fo:block>

											</xsl:if>

											</xsl:for-each>
										</fo:table-cell>

										<fo:table-cell padding="2pt" border="solid black">
											<xsl:for-each select="key('itemByFullpath', @NameFullPath)">
											<xsl:sort select="@TS_SecDesc.SecDescNm"/>

											<xsl:if test="count(. | key('itemBySecDescNm', concat(@NameFullPath,' ',@TS_SecDesc.SecDescNm))[1]) = 1">																					
											<fo:block text-align="start">
												<xsl:value-of select="@TS_SecDesc.SecDescNm" />
											</fo:block>
											</xsl:if>
											</xsl:for-each>
										</fo:table-cell>


									</fo:table-row>

							</xsl:for-each>

						</fo:table-body>
					</fo:table>

					<fo:block id="terminator"/>

				</fo:flow>

			</fo:page-sequence>
		</fo:root>
	</xsl:template>

</xsl:stylesheet>